package wekan.wrapper.api;

import retrofit2.Call;
import retrofit2.http.*;
import wekan.wrapper.entity.Board;
import wekan.wrapper.entity.MemberPermission;
import wekan.wrapper.entity.BoardPrototype;

import java.util.List;

public interface BoardService {
    @GET("api/boards")
    Call<List<Board>> getPublicBoards();

    @POST("api/boards")
    Call<Board> newBoard(@Body BoardPrototype boardPrototype);

    @GET("api/boards/{boardId}")
    Call<Board> getBoard(@Path("boardId") String boardId);

    @DELETE("api/boards/{boardId}")
    Call<Void> deleteBoard(@Path("boardId") String boardId);

    @POST("/api/boards/{boardId}/members/{memberId}")
    Call<Void> setBoardMemberPermission(
            @Path("boardId") String board,
            @Path("memberId") String member,
            @Body MemberPermission memberPermission
    );

    @GET("api/users/{userId}/boards")
    Call<List<Board>> getBoardsFromUser(@Path("userId") String userId);
}
